
// constants
const  reminderFox_TOOLTIP_LINE_LENGTH = 100;
const reminderFox_TOOLTIP_WITH_TODOS_LINE_LENGTH = 65;
const reminderFox_STATUS_TEXT_MAX_LENGTH = 40;
const reminderFox_ALERT_TEXT_MAX_LENGTH = 100;
const reminderFox_MONTHLY_WILDCARD = "*";


// Cache the last reminders
var reminderFox_lastReminders = null;
var reminderFox_lastTodos = null;
var reminderFox_lastDay = null;

// Launches the 'edit reminder' dialog, fills in Reminders list
function reminderFox_openAddRemindersDialog() {
   var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
   var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
   var topWindow = windowManagerInterface.getMostRecentWindow("window:reminderFoxEdit");
 
   if (topWindow) {
    	 topWindow.focus();
   }
   else {
		window.openDialog("chrome://reminderfox/content/addreminder-dialog.xul",
			"addreminder-dialog", "chrome,centerscreen,resizable", "reminders");
	}
}


function reminderFox_openOptionsDialog() {
   var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
   var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
   var topWindow = windowManagerInterface.getMostRecentWindow("window:reminderFoxOptions");
 
   if (topWindow) {
    	 topWindow.focus();
   }
   else {
		window.openDialog('chrome://reminderFox/content/options.xul', 'reminderFox-options', 'chrome');
	}
}


// Launches the 'edit reminder' dialog, fills in Reminders list
function reminderFox_openAddTodosDialog() {
   var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
   var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
   var topWindow = windowManagerInterface.getMostRecentWindow("window:reminderFoxEdit");
 
   if (topWindow) {
    	 topWindow.focus();
   }
   else {
	window.openDialog("chrome://reminderfox/content/addreminder-dialog.xul", 
		"addreminder-dialog", "chrome,centerscreen,resizable", "todos");
	}
}

function reminderFox_openDoubleClickDialog() {
	var defaultEditType = REMINDER_FOX_DEFAULT_EDIT_DEFAULT;			
	try {
		defaultEditType = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_DEFAULT_EDIT);
	} catch(e) {
	}	
	
	if ( defaultEditType == "todos" )  {
		reminderFox_openAddTodosDialog();
	}
	else {
		reminderFox_openAddRemindersDialog();
	}

}

// Launches the 'edit reminder' dialog, fills in Reminders list
function reminderFox_openAboutReminderFoxDialog() {
	window.openDialog("chrome://reminderfox/content/about.xul", "about", "chrome,centerscreen");
}


function reminderFox_deleteRecentOneTimeEvents() {
	var NUM_OF_DAYS = 7;
	
	var reminders = reminderFox_prefs.getCharPref(REMINDER_FOX_REMINDERS);
	
	var reminderString = "";

	var currentDate = new Date();
	var year = currentDate.getFullYear();
	var month = currentDate.getMonth();
	var day = currentDate.getDate();

	var dayArray;
	if (reminderFox_isLeapYear(parseInt(year))) {
		dayArray = REMINDER_FOX_lDOMonth;
	}
	else {
		dayArray = REMINDER_FOX_DOMonth;
	}

	var dayOfYear=0;
	for (var i=0; i < month; i++) {
		dayOfYear += parseInt(dayArray[i]);
	}
	dayOfYear += parseInt(day);

	var combo = REMINDER_PROPERTY_DELIMITER + REMINDER_FOX_OCCURRENCE_ONCE;
	var onetimeReminderIndex = reminders.indexOf( combo + REMINDER_SEPARATOR );
	if ( onetimeReminderIndex == -1 ) {
		if ( (reminders.lastIndexOf( combo ) + combo.length ) == (reminders.length -1) ) {
			onetimeReminderIndex = reminders.lastIndexOf( combo );
		}
	}
	var remindersToBeRemoved = "";	
		
	while ( onetimeReminderIndex != -1 ) {
		// we've found a one-time reminder.  Let's check if it is within say 7 days of the current date.  
		var startIndex = reminders.lastIndexOf( REMINDER_SEPARATOR, onetimeReminderIndex );
		if ( startIndex == -1 ) {
			startIndex = 0;
		}
		var currentReminder = reminders.substring( startIndex, onetimeReminderIndex + combo.length );
		
		var trimReminder = currentReminder;
		if ( trimReminder.indexOf( REMINDER_SEPARATOR ) == 0 ) {
			trimReminder = trimReminder.substring( 1, trimReminder.length );
		}
		if ( trimReminder.lastIndexOf( REMINDER_SEPARATOR ) == trimReminder.length -1 ) {
			trimReminder = trimReminder.substring( 0, trimReminder.length - 1);
		}
		var reminderArray = trimReminder.split(REMINDER_PROPERTY_DELIMITER);
		var dayOfYearOfReminder= 0;
		for (var j=0; j < reminderArray[0]; j++) {
			dayOfYearOfReminder += parseInt(dayArray[j]);
		}		
		dayOfYearOfReminder += parseInt(reminderArray[1]);
				
		var diff = dayOfYear - dayOfYearOfReminder;
		var endDiff = -365 + NUM_OF_DAYS;

		// if the reminder is a one-time reminder that occurred in the last NUM_OF_DAYS, we'll
		// remove him
		if ((diff <= NUM_OF_DAYS && diff > 0) || diff < endDiff ) {
			// mark this reminder for removal
			if ( currentReminder.indexOf( REMINDER_SEPARATOR ) == 0 && 
				remindersToBeRemoved.lastIndexOf( REMINDER_SEPARATOR ) == remindersToBeRemoved.length - 1 ) {	
				currentReminder = currentReminder.substring( 1, currentReminder.length );						
			}
			remindersToBeRemoved = remindersToBeRemoved + currentReminder;
		
			if ( remindersToBeRemoved.lastIndexOf( REMINDER_SEPARATOR ) != remindersToBeRemoved.length - 1 ) {
				remindersToBeRemoved = remindersToBeRemoved + REMINDER_SEPARATOR;
			}
		}

	    onetimeReminderIndex = reminders.indexOf( REMINDER_PROPERTY_DELIMITER + REMINDER_FOX_OCCURRENCE_ONCE + REMINDER_SEPARATOR,
	    	 onetimeReminderIndex + combo.length + 1 );
	    if ( onetimeReminderIndex == -1 ) {
			if ( (reminders.lastIndexOf( combo ) + combo.length ) == (reminders.length -1) ) {
				onetimeReminderIndex = reminders.lastIndexOf( combo );
			}
		}
	}
	
	if ( remindersToBeRemoved.lastIndexOf( REMINDER_SEPARATOR ) == remindersToBeRemoved.length - 1 ) {
		remindersToBeRemoved = remindersToBeRemoved.substring( 0, remindersToBeRemoved.length - 2 );
	}

	// now let's remove our reminders
	if ( remindersToBeRemoved != "" ) {
		var reminderArray = remindersToBeRemoved.split(REMINDER_SEPARATOR);
		for(var i=0; i < reminderArray.length; i++) {	
			var reminderToRemove = reminderArray[i];
			var indexOfReminderToRemove = reminders.indexOf(reminderToRemove);
			var leftSideOfReminders; 
			var rightSideOfReminders;
			var endIndex = reminders.indexOf( REMINDER_SEPARATOR, indexOfReminderToRemove + 1 );
			if ( endIndex != -1 ) {
				
				leftSideOfReminders = reminders.substring(0, indexOfReminderToRemove );
				if ( indexOfReminderToRemove > 0 ) {	
					leftSideOfReminders = leftSideOfReminders.substring(0, leftSideOfReminders.length -1 );  // remove REMINDER_SEPARATOR
				}
				rightSideOfReminders = reminders.substring(endIndex,  reminders.length);
			}
			else {
				leftSideOfReminders = reminders.substring(0, indexOfReminderToRemove );
				rightSideOfReminders = "";
			}
		
			// trim separators from beginning or end
			var finalReminders = leftSideOfReminders + rightSideOfReminders
			if ( finalReminders.indexOf( REMINDER_SEPARATOR ) == 0 ) {
				finalReminders = finalReminders.substring( 1, finalReminders.length );
			}	
			if ( finalReminders.lastIndexOf( REMINDER_SEPARATOR ) == finalReminders.length - 1 ) {
				finalReminders = finalReminders.substring( 0, finalReminders.length - 1);
			}
	
			reminders = finalReminders;
		}

		reminderFox_prefs.setCharPref(REMINDER_FOX_REMINDERS, reminders);	
	}	
}


function reminderFox_updateNonCompletedReminders() {
	var NUM_OF_DAYS = 7;
	
	var reminders = reminderFox_prefs.getCharPref(REMINDER_FOX_REMINDERS);
	
	var reminderString = "";

	var currentDate = new Date();
	var year = currentDate.getFullYear();
	var month = currentDate.getMonth();
	var day = currentDate.getDate();

	var dayArray;
	if (reminderFox_isLeapYear(parseInt(year))) {
		dayArray = REMINDER_FOX_lDOMonth;
	}
	else {
		dayArray = REMINDER_FOX_DOMonth;
	}

	var dayOfYear=0;
	for (var i=0; i < month; i++) {
		dayOfYear += parseInt(dayArray[i]);
	}
	dayOfYear += parseInt(day);

	var combo = REMINDER_PROPERTY_DELIMITER + REMINDER_TO_BE_COMPLETED_DELIMITER;
	var completeReminderIndex = reminders.indexOf( combo );

	var remindersToBeRemoved = "";	
	var remindersToBeAdded = "";
		
	while ( completeReminderIndex != -1 ) {
		// we've found a Reminder to be completed.  Let's check if it is within say 7 days of the current date.  
		var startIndex = reminders.lastIndexOf( REMINDER_SEPARATOR, completeReminderIndex );
		if ( startIndex == -1 ) {
			startIndex = 0;
		}
				
		var endIndex = reminders.indexOf( REMINDER_SEPARATOR, completeReminderIndex );
		if ( endIndex == -1 ) {
			endIndex = reminders.length;
		}
		
		var currentReminder = reminders.substring( startIndex, endIndex );
		
		var trimReminder = currentReminder;
		if ( trimReminder.indexOf( REMINDER_SEPARATOR ) == 0 ) {
			trimReminder = trimReminder.substring( 1, trimReminder.length );
		}
		if ( trimReminder.lastIndexOf( REMINDER_SEPARATOR ) == trimReminder.length -1 ) {
			trimReminder = trimReminder.substring( 0, trimReminder.length - 1);
		} 
		
		var isMonthly = false;
		var reminderArray = trimReminder.split(REMINDER_PROPERTY_DELIMITER);
		if ( reminderArray[0] == REMINDER_FOX_MONTHLY_WILDCARD_CHAR ) {	
			isMonthly = true;	
			reminderArray[0] = month;
		}

		var dayOfYearOfReminder= 0;
		for (var j=0; j < reminderArray[0]; j++) {
			dayOfYearOfReminder += parseInt(dayArray[j]);
		}		
		dayOfYearOfReminder += parseInt(reminderArray[1]);

		var diff = dayOfYear - dayOfYearOfReminder;
		var endDiff = -365 + NUM_OF_DAYS;

		// if the reminder is a Remind Until Completed reminder that occurred in 
		// the last NUM_OF_DAYS, we'll remove it, and re-add at the current date
		if ((diff <= NUM_OF_DAYS && diff > 0) || diff < endDiff ) {
			// mark this reminder for removal
			if ( currentReminder.indexOf( REMINDER_SEPARATOR ) == 0 && 
				remindersToBeRemoved.lastIndexOf( REMINDER_SEPARATOR ) == remindersToBeRemoved.length - 1 ) {	
				currentReminder = currentReminder.substring( 1, currentReminder.length );						
			}
			remindersToBeRemoved = remindersToBeRemoved + currentReminder;
			if ( remindersToBeRemoved.lastIndexOf( REMINDER_SEPARATOR ) != remindersToBeRemoved.length - 1 ) {
				remindersToBeRemoved = remindersToBeRemoved + REMINDER_SEPARATOR;
			}
			
			// check for Completed status
			var indexCompleted = trimReminder.indexOf( REMINDER_PROPERTY_DELIMITER + REMINDER_TO_BE_COMPLETED_DELIMITER );	
			if ( indexCompleted != -1 ) {
				var endIndexCompleted = trimReminder.indexOf( REMINDER_PROPERTY_DELIMITER, indexCompleted + 1  );
				if ( endIndexCompleted == -1 ) {
					endIndexCompleted = trimReminder.length - 1;
				}
				else {
					endIndexCompleted = endIndexCompleted - 1;
				}
				
				// if a length of 1 only, then it's marked as complete.  Skip it.
				if ( indexCompleted + 1 == endIndexCompleted )  {
					var newReminder =	trimReminder.substring( 0, indexCompleted ) +
							trimReminder.substring( indexCompleted + 2 );
					remindersToBeAdded = remindersToBeAdded + newReminder + REMINDER_SEPARATOR;	
					completeReminderIndex = reminders.indexOf( combo, endIndex + 1 );
					continue;
				}
			}
			
			// if it is a monthly reminder that is marked to Remind Until Completed...
			// Then we'll add a separate one-time RUC reminder, and change the monthly
			// reminder back to normal (without an RUC)
			if ( isMonthly ) {
				var preExistingDay;
				// add a new one-time reminder 
				var newReminder = "";
				var reminderArray = currentReminder.split(REMINDER_PROPERTY_DELIMITER);
				newReminder = month + REMINDER_PROPERTY_DELIMITER + day;
				for ( var j=2; j < reminderArray.length; j++ ) {
					if ( reminderArray[j].indexOf( REMINDER_TO_BE_COMPLETED_DELIMITER ) == 0 ) {
						var dateSeparatorIndex = reminderArray[j].indexOf( "-" );
						preExistingDay = reminderArray[j].substring( dateSeparatorIndex+1, reminderArray[j].length );
						newReminder = newReminder + REMINDER_PROPERTY_DELIMITER + 
							REMINDER_TO_BE_COMPLETED_DELIMITER + month + "-" + preExistingDay;
					}
					else {
						newReminder = newReminder + REMINDER_PROPERTY_DELIMITER + reminderArray[j];
					}
				}
				remindersToBeAdded = remindersToBeAdded + newReminder + 
					REMINDER_PROPERTY_DELIMITER + REMINDER_FOX_OCCURRENCE_ONCE + REMINDER_SEPARATOR;		
					
				// add back monthly reminder, minus the Completed info
				newReminder = REMINDER_FOX_MONTHLY_WILDCARD_CHAR + REMINDER_PROPERTY_DELIMITER + preExistingDay;
				for (var  j=2; j < reminderArray.length; j++ ) {
					if ( reminderArray[j].indexOf( REMINDER_TO_BE_COMPLETED_DELIMITER ) != 0 ) {
						newReminder = newReminder + REMINDER_PROPERTY_DELIMITER + reminderArray[j];
					}
				}
				remindersToBeAdded = remindersToBeAdded + newReminder + REMINDER_SEPARATOR;	
			}
			else {
				// add the reminder to be added
				var newReminder = "";
				var reminderArray = currentReminder.split(REMINDER_PROPERTY_DELIMITER);
				newReminder = month + REMINDER_PROPERTY_DELIMITER + day;
				for ( var j=2; j < reminderArray.length; j++ ) {
					newReminder = newReminder + REMINDER_PROPERTY_DELIMITER + reminderArray[j];
				}
				remindersToBeAdded = remindersToBeAdded + newReminder + REMINDER_SEPARATOR;		
			}		
		}

	    completeReminderIndex = reminders.indexOf( combo, endIndex + 1 );
	}
	
	if ( remindersToBeRemoved.lastIndexOf( REMINDER_SEPARATOR ) == remindersToBeRemoved.length - 1 ) {
		remindersToBeRemoved = remindersToBeRemoved.substring( 0, remindersToBeRemoved.length - 2 );
	}
	if ( remindersToBeAdded.lastIndexOf( REMINDER_SEPARATOR ) == remindersToBeAdded.length - 1 ) {
		remindersToBeAdded = remindersToBeAdded.substring( 0, remindersToBeAdded.length - 1 );
	}

	// now let's remove our reminders
	if ( remindersToBeRemoved != "" ) {
		var reminderArray = remindersToBeRemoved.split(REMINDER_SEPARATOR);
		for(var i=0; i < reminderArray.length; i++) {	
			var reminderToRemove = reminderArray[i];
			var indexOfReminderToRemove = reminders.indexOf(reminderToRemove);
			var leftSideOfReminders; 
			var rightSideOfReminders;
			var endIndex = reminders.indexOf( REMINDER_SEPARATOR, indexOfReminderToRemove + 1 );
			if ( endIndex != -1 ) {				
				leftSideOfReminders = reminders.substring(0, indexOfReminderToRemove );
				if ( indexOfReminderToRemove > 0 ) {	
					leftSideOfReminders = leftSideOfReminders.substring(0, leftSideOfReminders.length -1 );  // remove REMINDER_SEPARATOR
				}
				rightSideOfReminders = reminders.substring(endIndex,  reminders.length);
			}
			else {
				leftSideOfReminders = reminders.substring(0, indexOfReminderToRemove );
				rightSideOfReminders = "";
			}
		
			// trim separators from beginning or end
			var finalReminders = leftSideOfReminders + rightSideOfReminders
			if ( finalReminders.indexOf( REMINDER_SEPARATOR ) == 0 ) {
				finalReminders = finalReminders.substring( 1, finalReminders.length );
			}	
			if ( finalReminders.lastIndexOf( REMINDER_SEPARATOR ) == finalReminders.length - 1 ) {
				finalReminders = finalReminders.substring( 0, finalReminders.length - 1);
			}
	
			reminders = finalReminders;
		}

		reminderFox_prefs.setCharPref(REMINDER_FOX_REMINDERS, reminders);	
	}
	// now let's add the new reminders
	if ( remindersToBeAdded != "" ) {
		var reminderArray = remindersToBeAdded.split(REMINDER_SEPARATOR);
		for( var i=0; i < reminderArray.length; i++) {			
			var reminderToAdd = reminderArray[i];	
			var reminderToBeAddedArray = reminderToAdd.split(REMINDER_PROPERTY_DELIMITER);
			reminders = reminderFox_sortNewReminder( reminders, reminderToAdd, reminderToBeAddedArray[0], reminderToBeAddedArray[1] );		
		}		
		reminderFox_prefs.setCharPref(REMINDER_FOX_REMINDERS, reminders);	
	}
	
}


function reminderFox_createToolTip(todayRemindersArr) {
	// we'll set the icon depending on if there's current, upcoming, 
	// or no reminders
 	var icon = document.getElementById('reminderFox-statusLabel');
 	icon.setAttribute("status", "noReminders");

 	var upcomingRemindersArr = reminderFox_getUpcomingReminders();
 	var todosArr = reminderFox_getTodos();

 	// clear old tooltips
	var todayBox = document.getElementById("todaysRemindersBox");
	if ( todayBox != null ) {
		var todaysremindersList = todayBox.childNodes;
		for (var j=0; j < todaysremindersList.length; j++) {
			var currentNode = todaysremindersList[j];
			todayBox.removeChild(currentNode);
		}
	}
					
	var upcomingBox = document.getElementById("upcomingRemindersBox");
	if ( upcomingBox != null ) {
		var upcomingremindersList = upcomingBox.childNodes;
		for (var j=0; j < upcomingremindersList.length; j++) {
			var currentNode = upcomingremindersList[j];
			upcomingBox.removeChild(currentNode);
		}
	}
	
	var todoBox = document.getElementById("todosBox");
	if ( todoBox != null ) {
		var todosList = todoBox.childNodes;
		for (var j=0; j < todosList.length; j++) {
			var currentNode = todosList[j];
			todoBox.removeChild(currentNode);
		}
	}
		
	// remove old tooltip box
	var tooltipChildren = document.getElementById("tooltipChildren");
	var todoDescription = document.getElementById( "todoDescription" );
	if ( todoDescription != null ) {
		tooltipChildren.removeChild( todoDescription );
	}
	var todosBox = document.getElementById( "todosBox" );
	if ( todosBox != null ) {
		tooltipChildren.removeChild( todosBox );		
	}
	
	// remove old reminders box
	var tooltipChildrenReminders = document.getElementById("tooltipChildrenReminders");
	var todayDescription = document.getElementById( "todayRemindersDescription" );
	if ( todayDescription != null ) {
		tooltipChildrenReminders.removeChild( todayDescription );
	}
	
	var todayBox = document.getElementById( "todaysRemindersBox" );
	if ( todayBox != null ) {
		tooltipChildrenReminders.removeChild( todayBox );		
	}
	
	var todayBox = document.getElementById( "reminderSpacer" );
	if ( todayBox != null ) {
		tooltipChildrenReminders.removeChild( todayBox );		
	}

	var upcomingDescription = document.getElementById( "upcomingRemindersDescription" );
	if ( upcomingDescription != null ) {
		tooltipChildrenReminders.removeChild( upcomingDescription );
	}
	
	var upcomingBox = document.getElementById( "upcomingRemindersBox" );
	if ( upcomingBox != null ) {
		tooltipChildrenReminders.removeChild( upcomingBox );		
	}	

	var showReminders = true;			
	try {
		showReminders = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_SHOW_REMINDERS_IN_TOOLTIP);
	} catch(e) {
	}			

	var showTooltips = true;			
	try {
		showTooltips = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_SHOW_TODOS_IN_TOOLTIP);
	} catch(e) {
	}			
 	
 	var tooltipWrapLength;
 	if ( todosArr.length > 0 && showReminders && showTooltips) {
 		tooltipWrapLength = reminderFox_TOOLTIP_WITH_TODOS_LINE_LENGTH;
 	}
 	else {
 		tooltipWrapLength = reminderFox_TOOLTIP_LINE_LENGTH;
 	}

 	if ( showReminders ) { 
 			var todayDescription = document.createElement("description");
			todayDescription.setAttribute("id", "todayRemindersDescription");
			todayDescription.setAttribute("value", "Today's Reminders");
			todayDescription.setAttribute("style", "font-weight:bold;");
			tooltipChildrenReminders.appendChild(todayDescription);
	
			var todayVbox = document.createElement("vbox");
			todayVbox.setAttribute("id", "todaysRemindersBox");
			tooltipChildrenReminders.appendChild(todayVbox);
 				
			var spacer =  	document.createElement("spacer");	
 			spacer.setAttribute("id", "reminderSpacer");		
 			spacer.setAttribute("height", "4px");		
			tooltipChildrenReminders.appendChild(spacer); 			
 		
 	 		var upcomingDescription = document.createElement("description");
			upcomingDescription.setAttribute("id", "upcomingRemindersDescription");
			upcomingDescription.setAttribute("value", "Upcoming Reminders");
			upcomingDescription.setAttribute("style", "font-weight:bold;");
			tooltipChildrenReminders.appendChild(upcomingDescription);

			var upcomingVbox = document.createElement("vbox");
			upcomingVbox.setAttribute("id", "upcomingRemindersBox");
			tooltipChildrenReminders.appendChild(upcomingVbox);

	 		reminderFox_populateTodayToolTip(todayRemindersArr, tooltipWrapLength );
	 		reminderFox_populateUpcomingToolTip(upcomingRemindersArr, tooltipWrapLength);
	}
	
	if ( showTooltips && todosArr.length > 0 ) {
		var todoDescription = document.createElement("description");
		todoDescription.setAttribute("id", "todoDescription");
		todoDescription.setAttribute("value", "ToDo's");
		todoDescription.setAttribute("style", "font-weight:bold;");
		tooltipChildren.appendChild(todoDescription);
		
		var todosVbox = document.createElement("vbox");
		todosVbox.setAttribute("id", "todosBox");
		tooltipChildren.appendChild(todosVbox);
		reminderFox_populateTodoToolTip(todosArr, (tooltipWrapLength - 13));	
	}
 		
	if ( todayRemindersArr.length > 0 ) {
		icon.setAttribute("status", "currentReminder");
	}
	else if ( upcomingRemindersArr.length > 0 ) {
		icon.setAttribute("status", "upcomingReminder");
	}	
}

function reminderFox_populateTodayToolTip(remindersArr, tooltipWrapLength) {
	var lblparent = document.getElementById("todaysRemindersBox");
	if (remindersArr.length > 0 ) {

		var lineWrappedIndent = 5;	
		for(var i=0; i < remindersArr.length; i++) {		
			var startIndex = 0;
			var remainingString = remindersArr[i].reminder;
			var afterFirst = false;
			while ( remainingString.length > tooltipWrapLength  ) {				
				// go back to last whitespace
				var lastIndex = remainingString.lastIndexOf( ' ', tooltipWrapLength );
				var forceLineBreak = false;
				if ( lastIndex == -1 ) {
					forceLineBreak = true;
			    	lastIndex = tooltipWrapLength + 1;
				}
				if ( lastIndex != -1 ) {
				    var curStr = remainingString.substring( 0, lastIndex );
				    // after the first line, for any extra lines we will indent some.This makes
				    // the entry look nice when wrapping to the following lines
				    if ( afterFirst )  {
				    	var j = 0;
				    	while ( j < lineWrappedIndent ) {
				    		curStr = " " + curStr;
				    		j++;
				    	}
				    }	
				    	    
				    var remLabel = document.createElement("description");
					remLabel.setAttribute("value", curStr);
					if ( remindersArr[i].important ) { 
						remLabel.setAttribute("style", "color: red;");
					}
					else {
						remLabel.setAttribute("style", "color: black;");
					}
					lblparent.appendChild(remLabel);
					afterFirst = true;
				}
				
				if ( forceLineBreak ) {
					startIndex = lastIndex;
				}
				else {
					startIndex = lastIndex + 1;
				}
				remainingString = remainingString.substring( startIndex );		  										
			}
			if ( afterFirst )  {
			   	var j = 0;
			   	while ( j < lineWrappedIndent ) {
			   		remainingString = " " + remainingString;
			   		j++;
			   	}
			}			

			var remLabel = document.createElement("description");
			remLabel.setAttribute("value", remainingString);
			if ( remindersArr[i].important ) { 
				remLabel.setAttribute("style", "color: red;");
			}
			else {
				remLabel.setAttribute("style", "color: black;");
			}
			lblparent.appendChild(remLabel);
		}
	} else {
		var noneLabel = document.createElement("description");
		noneLabel.setAttribute("value", "none");
		lblparent.appendChild(noneLabel);
	}
}


function reminderFox_populateUpcomingToolTip( remindersArr, tooltipWrapLength) {
	var lblparent = document.getElementById("upcomingRemindersBox");
	if (remindersArr.length > 0 ) {
		for(var i=0; i < remindersArr.length; i++) {	
			var remainingString = remindersArr[i].reminder;

			var lineWrappedIndent = 5;	
				
			var startIndex = 0;
			var afterFirst = false;
			while ( remainingString.length > tooltipWrapLength ) {				
				// go back to last whitespace
				var lastIndex = remainingString.lastIndexOf( ' ', tooltipWrapLength );
				var forceLineBreak = false;
				if ( lastIndex == -1 ) {
					forceLineBreak = true;
			    	lastIndex = tooltipWrapLength + 1;
				}				
				if ( lastIndex != -1 ) {
				    var curStr = remainingString.substring( 0, lastIndex );
				    // after the first line, for any extra lines we will indent some. This makes
				    // the entry look nice when wrapping to the following lines
				    if ( afterFirst )  {
				    	var j = 0;
				    	while ( j < lineWrappedIndent ) {
				    		curStr = " " + curStr;
				    		j++;
				    	}
				    }				    
				    
				    var remLabel = document.createElement("description");
					remLabel.setAttribute("value", curStr);
					if ( remindersArr[i].important ) { 
						remLabel.setAttribute("style", "color: red;");
					}
					else {
						remLabel.setAttribute("style", "color: black;");
					}
					lblparent.appendChild(remLabel);
					afterFirst = true;
				}
								
				if ( forceLineBreak ) {
					startIndex = lastIndex;
				}
				else {
					startIndex = lastIndex + 1;
				}
				remainingString = remainingString.substring( startIndex );				    										
			}
			if ( afterFirst )  {
			   	var j = 0;
			   	while ( j < lineWrappedIndent ) {
			   		remainingString = " " + remainingString;
			   		j++;
			   	}
			}
			
			var remLabel = document.createElement("description");			
			remLabel.setAttribute("value", remainingString);
			if ( remindersArr[i].important ) { 
				remLabel.setAttribute("style", "color: red;");
			}
			else {
				remLabel.setAttribute("style", "color: black;");
			}
			lblparent.appendChild(remLabel);
		}
	} else {
		var noneLabel = document.createElement("description");
		noneLabel.setAttribute("value", "none");
		lblparent.appendChild(noneLabel);
	}
}


function reminderFox_populateTodoToolTip( todosArr, tooltipWrapLength) {
	var todosBox = document.getElementById("todosBox");
	
	if (todosArr.length > 0 ) {
		for(var i=0; i < todosArr.length; i++) {	
			var remainingString = todosArr[i].reminder;
		
			var lineWrappedIndent = 5;
			
			var startIndex = 0;
			var afterFirst = false;
			while ( remainingString.length > tooltipWrapLength ) {				
				// go back to last whitespace
				var lastIndex = remainingString.lastIndexOf( ' ', tooltipWrapLength );
				var forceLineBreak = false;
				if ( lastIndex == -1 ) {
					forceLineBreak = true;
			    	lastIndex = tooltipWrapLength + 1;
				}					
				if ( lastIndex != -1 ) {
				    var curStr = remainingString.substring( 0, lastIndex );
				    // after the first line, for any extra lines we will indent some.  This makes
				    // the entry look nice when wrapping to the following lines
				    if ( afterFirst )  {
				    	var j = 0;
				    	while ( j < lineWrappedIndent ) {
				    		curStr = " " + curStr;
				    		j++;
				    	}
				    }				    
				    
				    var remLabel = document.createElement("description");
					remLabel.setAttribute("value", curStr);
					if ( todosArr[i].important ) { 
						remLabel.setAttribute("style", "color: red;");
					}
					else {
						remLabel.setAttribute("style", "color: black;");
					}
					todosBox.appendChild(remLabel);
					afterFirst = true;
				}
								
				if ( forceLineBreak ) {
					startIndex = lastIndex;
				}
				else {
					startIndex = lastIndex + 1;
				}
				remainingString = remainingString.substring( startIndex );				    										
			}
			if ( afterFirst )  {
			   	var j = 0;
			   	while ( j < lineWrappedIndent ) {
			   		remainingString = " " + remainingString;
			   		j++;
			   	}
			}
			
			var remLabel = document.createElement("description");			
			remLabel.setAttribute("value", remainingString);
			if ( todosArr[i].important ) { 
				remLabel.setAttribute("style", "color: red;");
			}
			else {
				remLabel.setAttribute("style", "color: black;");
			}
			todosBox.appendChild(remLabel);
		}
	} else {
		var noneLabel = document.createElement("description");
		noneLabel.setAttribute("value", "none");
		todosBox.appendChild(noneLabel);
	}
}

function reminderFox_getUpcomingReminders() {
	var reminders = reminderFox_prefs.getCharPref(REMINDER_FOX_REMINDERS);
	var remindersArray = reminders.split(REMINDER_SEPARATOR);

	var currentDate = new Date();
	var month = parseInt(currentDate.getMonth());
	var day = parseInt(currentDate.getDate());
	var year = parseInt(currentDate.getFullYear());

	var dayArray;
	if (reminderFox_isLeapYear(parseInt(year))) {
		dayArray = REMINDER_FOX_lDOMonth;
	}
	else {
		dayArray = REMINDER_FOX_DOMonth;
	}

	var dayOfYear=0;
	for (var i=0; i < month; i++) {
		dayOfYear += parseInt(dayArray[i]);
	}
	dayOfYear += parseInt(day);

	var reminderString = "";
	for(var i = 0; i < remindersArray.length; i++) {
		var reminder = remindersArray[i];
		var reminderArray = reminder.split(REMINDER_PROPERTY_DELIMITER);
		var dayOfYearOfReminder = 0;
		var isMonthly = false;
		if ( reminderArray[0] == REMINDER_FOX_MONTHLY_WILDCARD_CHAR ) {	
			isMonthly = true;	
			reminderArray[0] = month;

			reminderArray[1] = reminderFox_getValidDateForMonth( new Date().getFullYear(), reminderArray[0], reminderArray[1] );		
			
			var dayOfYearOfReminder= 0;
			for (var j=0; j < reminderArray[0]; j++) {
				dayOfYearOfReminder += parseInt(dayArray[j]);
			}		
			dayOfYearOfReminder += parseInt(reminderArray[1]);
			if ( dayOfYearOfReminder < dayOfYear ) {
				// this month's reminder has passed; let's use next month
				reminderArray[0] = (month + 1) % 11;
				var dayOfYearOfReminder= 0;
				for (var j=0; j < reminderArray[0]; j++) {
					dayOfYearOfReminder += parseInt(dayArray[j]);
				}		
				dayOfYearOfReminder += parseInt(reminderArray[1]);
			}						
		}		
		else {
			for (var j=0; j < reminderArray[0]; j++) {
				dayOfYearOfReminder += parseInt(dayArray[j]);
			}		
			dayOfYearOfReminder += parseInt(reminderArray[1]);
		}

		var upcomingReminderDays = parseInt(reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + UPCOMING_REMINDER_DAYS_PREF));

		var diff = dayOfYearOfReminder - dayOfYear;
		var endDiff = -365 + upcomingReminderDays;				
		if ((diff < upcomingReminderDays && diff > 0) || diff < endDiff ) {	
			// check for Completed status
			var indexCompleted = reminder.indexOf( REMINDER_PROPERTY_DELIMITER + REMINDER_TO_BE_COMPLETED_DELIMITER );	
			if ( indexCompleted != -1 ) {
				var endIndex = reminder.indexOf( REMINDER_PROPERTY_DELIMITER, indexCompleted + 1  );
				if ( endIndex == -1 ) {
					endIndex = reminder.length - 1;
				}
				else {
					endIndex = endIndex - 1;
				}
				
				// if a length of 1 only, then it's marked as complete.  Skip it.
				if ( indexCompleted + 1 == endIndex )  {
					continue;
				}
			}
						
			if ( isMonthly ) {
				// if it's a monthly reminder, it appears at the end of the list, so
				// we need to add it in the proper sorted order
				var str = reminderFox_getMonthAsText(reminderArray[0]) + " " + reminderArray[1] + ":  "  + reminderArray[2];
				
				
				var importantStatus = false;		
				if ( reminderArray.length > 3 ) {
			        for (var j = 3; j < reminderArray.length; j++ ) {
			           	 var val = reminderArray[j];
						 if ( val == REMINDER_IMPORTANT_FLAG ) {
			                importantStatus = true;
			            }
			        }
		   		}
								
				if ( importantStatus ) {			
					str = str + REMINDER_PROPERTY_DELIMITER + "!";
				}	
				if (reminderString.length == 0) {
					reminderString += str;
				} 
				else {
					reminderString = reminderFox_sortNewUpcomingReminder( reminderString, str, reminderArray[0], reminderArray[1] );
				}
			}
			else {
				if (reminderString.length == 0) {
					reminderString += reminderFox_getMonthAsText(reminderArray[0]) + " " + reminderArray[1] + ":  "  + reminderArray[2];
				} 
				else {					
					reminderString += REMINDER_SEPARATOR + reminderFox_getMonthAsText(reminderArray[0]) + " " + reminderArray[1] + ":  "  + reminderArray[2];
				}	
				
				
				var importantStatus = false;		
				if ( reminderArray.length > 3 ) {
			        for (var  j = 3; j < reminderArray.length; j++ ) {
			           	 var val = reminderArray[j];
						 if ( val == REMINDER_IMPORTANT_FLAG ) {
			                importantStatus = true;
			            }
			        }
		   		}
				
				
				if ( importantStatus ) {				
					reminderString = reminderString + REMINDER_PROPERTY_DELIMITER + "!";
				}	
			}
		}
	}
	
	
	// now create new container classes
	var arr;
	if ( reminderString.length > 0 ) {
		remindersArray = reminderString.split(REMINDER_SEPARATOR);
		arr = new Array( remindersArray.length );
		for(var i = 0; i < remindersArray.length; i++) {
			var reminder = remindersArray[i];
			var reminderArray = reminder.split(REMINDER_PROPERTY_DELIMITER);
			var importantStatus = reminderArray.length > 1;
			
			var myReminder = new ReminderContainer(reminderArray[0], importantStatus);
			arr[i] = myReminder;
		}
	}
	else {
		arr = new Array( 0 );
	}
	
	return arr;
}


function reminderFox_sortNewUpcomingReminder( reminders, newreminder, myMonth, myDay  ) {
	// We go through each reminder and then compare that reminder's month with 
	// the reminder-to-be-added month, and if the new month is less, add there;
	// if the months are equal, then compare the days and add appropriately. 
	if (reminders != "") {
	 	var index = 0;
		var endIndex = reminders.indexOf( REMINDER_SEPARATOR );
		if ( endIndex == -1 ) {
			endIndex = reminders.length - 1;
		}
		var added = false;
		while ( endIndex != -1 && !added ) {
			var currentReminder = reminders.substring( index, endIndex );
			
			var monthIndex = currentReminder.indexOf( " " );
			var month = currentReminder.substring( 0, monthIndex );
			
			var dayIndex = currentReminder.indexOf( ":" );
			var reminderDay = currentReminder.substring( monthIndex + 1, dayIndex  );

			var reminderMon = reminderFox_getMonthAsInteger( month );
			// add current reminder before reminders from later months
			if (  myMonth < reminderMon) { 
				var leftSideOfReminders = reminders.substring(0, index );						
				var rightSideOfReminders = reminders.substring(index ,  reminders.length);					
				reminders = leftSideOfReminders + newreminder + REMINDER_SEPARATOR + rightSideOfReminders;
				added = true;
			}
			// if they have the same month, then compare dates
			else if ( reminderMon == myMonth ) {
				var reminderDay = parseInt(reminderDay);
				if ( myDay < reminderDay ) {
					var leftSideOfReminders = reminders.substring(0, index );							
					var rightSideOfReminders = reminders.substring(index ,  reminders.length);					
					reminders = leftSideOfReminders + newreminder + REMINDER_SEPARATOR + rightSideOfReminders;
					added = true;
				}
			}
			index = endIndex + 1;
			endIndex = reminders.indexOf( REMINDER_SEPARATOR, index );		
			if ( index != reminders.length && endIndex == -1 ) {
				endIndex = reminders.length -1;
			}
		}
		
		// if the reminder hasn't been added yet, then place it at the end
		// of the list
		if ( !added ) {
			reminders += REMINDER_SEPARATOR + newreminder;
		}	
	}	
	else {
		reminders += newreminder;
	}	
	return reminders;
}


function reminderFox_getTodaysReminders(  ) {
	var reminders = reminderFox_prefs.getCharPref(REMINDER_FOX_REMINDERS);

	var remindersArray = reminders.split(REMINDER_SEPARATOR);
	var currentDate = new Date();
	var month = currentDate.getMonth();
	var day = currentDate.getDate();
	
	var reminderString = "";
	for(var i = 0; i < remindersArray.length; i++) {
		var reminder = remindersArray[i];
		var reminderArray = reminder.split(REMINDER_PROPERTY_DELIMITER);
		// if it's a monthly reminder, treat it as a reminder for current month
		if ( reminderArray[0] == reminderFox_MONTHLY_WILDCARD ) {
			reminderArray[0] = month;
					
			reminderArray[1] = reminderFox_getValidDateForMonth( new Date().getFullYear(), reminderArray[0], reminderArray[1] );		
		}
		if (reminderArray[0] == month && reminderArray[1] == day) {
			// check for Completed status
			var indexCompleted = reminder.indexOf( REMINDER_PROPERTY_DELIMITER + REMINDER_TO_BE_COMPLETED_DELIMITER );	
			if ( indexCompleted != -1 ) {
				var endIndex = reminder.indexOf( REMINDER_PROPERTY_DELIMITER, indexCompleted + 1  );
				if ( endIndex == -1 ) {
					endIndex = reminder.length - 1;
				}
				else {
					endIndex = endIndex - 1;
				}
				
				// if a length of 1 only, then it's marked as complete.  Skip it.
				if ( indexCompleted + 1 == endIndex )  {
					continue;
				}
			}
			
			if (reminderString.length == 0)
				reminderString += reminderArray[2];
			else
				reminderString += REMINDER_SEPARATOR + reminderArray[2];
			
			var importantStatus = false;		
			if ( reminderArray.length > 3 ) {
		        for (var  j = 3; j < reminderArray.length; j++ ) {
		           	 var val = reminderArray[j];
					 if ( val == REMINDER_IMPORTANT_FLAG ) {
		                importantStatus = true;
		            }
		        }
	   		}
			
			
			if ( importantStatus ) {				
				reminderString = reminderString + REMINDER_PROPERTY_DELIMITER + "!";
			}		
		}
	}
	
	// now create new container classes
	var arr;
	if ( reminderString.length > 0 ) {
		remindersArray = reminderString.split(REMINDER_SEPARATOR);
		arr = new Array( remindersArray.length );
		for(var i = 0; i < remindersArray.length; i++) {
			var reminder = remindersArray[i];
			var reminderArray = reminder.split(REMINDER_PROPERTY_DELIMITER);
			var importantStatus = reminderArray.length > 1;
			var myReminder = new ReminderContainer(reminderArray[0], importantStatus);
			arr[i] = myReminder;
		}
	}
	else {
		arr = new Array( 0 );
	}
	return arr;
}

function reminderFox_getTodos(  ) {
	var todos = reminderFox_prefs.getCharPref(REMINDER_FOX_TODOS);

	var todosArray = todos.split(REMINDER_SEPARATOR);
	var arr = new Array( todosArray.length );
	var length = 0;
	for(var i = 0; i < todosArray.length; i++) {
		var todo = todosArray[i];
		var todoArray = todo.split(REMINDER_PROPERTY_DELIMITER);
		var importantStatus = false;
		var showInTooltip = false;
		if ( todoArray.length > 1 ) {
	        for (var  j = 1; j < todoArray.length; j++ ) {
	            var val = todoArray[j];
				 if ( val == REMINDER_IMPORTANT_FLAG ) {
	                importantStatus = true;
	            }
	            else if ( val.indexOf( REMINDER_TO_BE_COMPLETED_DELIMITER ) == 0 ) {
	                showInTooltip = true;	
	            }
	        }
   		}
		if ( showInTooltip ) {
			var myReminder = new ReminderContainer(todoArray[0], importantStatus);
			arr[length] = myReminder;	
			length++;	
		}
	}
	var retarr = new Array( length );
	for(var i = 0; i < length; i++) {
		retarr[i] = arr[i];
	}
	
	return retarr;
}


function reminderFox_storeTimeOfLastUpdate() {
	// output the last time of update for debugging, but only if the
	// preference already exists
	try {		
		reminderFox_prefs.getCharPref(REMINDER_FOX_LAST_UPDATE);
		var currentDate = new Date();
		var hours = currentDate.getHours();
		var mins = currentDate.getMinutes();
		var secs = currentDate.getSeconds();
		
		var readableMins = mins;
		if ( mins < 10 ) {
			readableMins = "0" + readableMins;
		}
		var readableSecs = secs;
		if ( secs < 10 ) {
			readableSecs = "0" + readableSecs;
		}
		reminderFox_prefs.setCharPref(REMINDER_FOX_LAST_UPDATE, hours + ":" + readableMins + ":" + readableSecs);	
	} catch(e) {
		// pref doesn't exist.  Do nothing.
	}	
}


function reminderFox_moveBox() { 
    //check if box is ind the right location
    var toolbar = document.getElementById(reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TOOLBAR));
    var box = document.getElementById("reminderFox-statusLabel");

    var position;
    try {
    	position = reminderFox_prefs.getIntPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_TOOLBAR_POSITION) ;
    }
    catch( e ) {
    	position = -1;
    }

    //if toolbar doesn't exist move to default location
    if (!toolbar) {
    	prefsBranch.setIntPref(REMINDER_FOX_TOOLBAR_POSITION, REMINDER_FOX_TOOLBAR_DEFAULT);
		prefsBranch.setIntPref(REMINDER_FOX_TOOLBAR_POSITION, REMINDER_FOX_TOOLBAR_POSITION_DEFAULT);      
     	return;
    }

    // bail if it is in the right place
    if (reminderFox_indexOf(toolbar,box, false) == position) {
	     return;
     }

    //remove us from parent
    box.parentNode.removeChild(box);

    reminderFox_insertAtIndex(toolbar, box, position);
  }
  

 function reminderFox_insertAtIndex(aParent, aChild, aIndex)  {
    var children = aParent.childNodes;
    if ((children.length == 0) || (aIndex >= children.length) || (aIndex < 0)) {
      aParent.appendChild(aChild);
     }
    else {
       aParent.insertBefore(aChild, children[aIndex]);
     }
  }

function reminderFox_storeTimeOfLastAlert() {
	// output the last time of update for debugging, but only if the
	// preference already exists
	try {		
		reminderFox_prefs.getCharPref(REMINDER_FOX_LAST_ALERT);
		var currentDate = new Date();
		var hours = currentDate.getHours();
		var mins = currentDate.getMinutes();
		var secs = currentDate.getSeconds();
		
		var readableMins = mins;
		if ( mins < 10 ) {
			readableMins = "0" + readableMins;
		}
		var readableSecs = secs;
		if ( secs < 10 ) {
			readableSecs = "0" + readableSecs;
		}
		reminderFox_prefs.setCharPref(REMINDER_FOX_LAST_ALERT, hours + ":" + readableMins + ":" + readableSecs);	
	} catch(e) {
		// pref doesn't exist.  Do nothing.
	}	
}


// this runs every hour and updates all of the windows with the latest reminders
function reminderFox_initializeReminderFox() {
	var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var windowEnumerator = windowManagerInterface.getEnumerator("navigator:browser");
	
	if (windowEnumerator.hasMoreElements()) {
		var oldestWindow = windowEnumerator.getNext();
		// if this is the very first (oldest) window opened, then let's process the reminders
		if ( window == oldestWindow ) {
			oldestWindow.reminderFox_loadReminderFox(false);	

			while (windowEnumerator.hasMoreElements()) {
				var currentWindow = windowEnumerator.getNext();		
				currentWindow.reminderFox_loadReminderFox(false);		
			}
			reminderFox_storeTimeOfLastUpdate();
		}

		window.setTimeout(reminderFox_initializeReminderFox, 3600000);  // 10000 == 10 sec min
	}
}

function reminderFox_loadReminderFox(forceUpdate) {
	try { 
		reminderFox_updateNonCompletedReminders();
		reminderFox_deleteRecentOneTimeEvents();
	}
	catch ( e ) {
	}

	var reminders;
	var todos;
	try {
		reminders = reminderFox_prefs.getCharPref(REMINDER_FOX_REMINDERS);
		todos	 = reminderFox_prefs.getCharPref(REMINDER_FOX_TODOS);
	}
	catch( e ) {
		reminders = "";
		todos = "";
	}
	var currentDate = new Date();
	var day = currentDate.getDate();

	//only process if reminders have changed since last load, or it is a different
	// day (new reminders may need to be shown in statusbar/tooltips	
	if ( forceUpdate || reminderFox_lastReminders != reminders || reminderFox_lastTodos != todos || reminderFox_lastDay  != day ) {
		reminderFox_lastReminders = reminders;
		reminderFox_lastTodos = todos;
		reminderFox_lastDay  = day;
		var text = document.getElementById('reminderFox-statusLabel');
		if (text != null) {
			var reminderString = "";

			var remindersArray =reminderFox_getTodaysReminders();
			var important = false;
			for ( var i = 0; i < remindersArray.length; i++ ) {
				reminderString = reminderString + remindersArray[i].reminder;
				if ( i < remindersArray.length - 1 ) { 
					reminderString = reminderString + ", ";
				}
				if ( remindersArray[i].important ) {
					important = true;
				}
			}
			if (reminderString != "") { 
				// don't want text on status bar too long; truncate it after it gets big
				if ( reminderString.length > reminderFox_STATUS_TEXT_MAX_LENGTH ) {
					reminderString = reminderString.substring( 0, reminderFox_STATUS_TEXT_MAX_LENGTH ) + "...";
				}					

				if ( important ) {
					text.setAttribute("style", "color: red;");
				}
				else{
				    text.setAttribute("style", "color: black;");
				}

				
				var showStatusText = true;
				try {
					showStatusText = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_SHOW_STATUS_TEXT);
				} catch(e) {
				}

				if ( showStatusText ) {
					text.setAttribute("class", "statusbarpanel-iconic-text");
					text.setAttribute("label", reminderString);					
				}
				else {
					// user doesn't want the reminder text - just use icon
					text.setAttribute("class", "statusbarpanel-iconic");
				}					
			} else {
				text.setAttribute("class", "statusbarpanel-iconic");
			}

			reminderFox_createToolTip(remindersArray);		
		}
	}
}


function reminderFox_activateOptionsContext(event) {	
	// dynamically handle the Show Alerts menu item 
	var alertType;
	try {
		alertType = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ENABLE_ALERT_PREF);
	} catch(e) {
		alertType = REMINDER_FOX_ENABLE_ALERT_PREF_ALL;
	}
			
	var showAlert = document.getElementById("options-contextmenu-showAlert");	
	
	// if the user has set it to no alerts, the option should be disabled
	if ( alertType == REMINDER_FOX_ENABLE_ALERT_PREF_NONE ) {
		showAlert.setAttribute("disabled", "true");
		showAlert.setAttribute("checked", "false");	    
	}
	// if alerts are suspended, the option is unchecked
	else if ( alertType.indexOf( REMINDER_FOX_SUSPEND_ALERT_PREF ) != -1 ) {
		showAlert.setAttribute("disabled", "false");
		showAlert.setAttribute("checked", "false");
		
	}
	// otherwise, in normal case the option is checked
	else {
		showAlert.setAttribute("disabled", "false");
		showAlert.setAttribute("checked", "true");
	}	

	var reminderFoxStatusbarPanel = document.getElementById("reminderFox-statusLabel");
	var optionsContextMenu = document.getElementById("options-contextmenu");
	var xCoord = event.clientX;
	var yCoord = event.clientY;
	document.popupNode = reminderFoxStatusbarPanel;
	optionsContextMenu.showPopup(reminderFoxStatusbarPanel, xCoord, yCoord, "bottomleft", "topleft");
}

function reminderFox_toggleShowAlert() {
	var alertType;
	try {
		alertType = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ENABLE_ALERT_PREF);
	} catch(e) {
		alertType = REMINDER_FOX_ENABLE_ALERT_PREF_ALL;
	}
	
	// if it's marked as suspended, change to original value
	var suspendedIndex = alertType.indexOf( REMINDER_FOX_SUSPEND_ALERT_PREF ) ;		
	if ( suspendedIndex != -1 ) {
		alertType = alertType.substring( suspendedIndex + REMINDER_FOX_SUSPEND_ALERT_PREF.length );
	}
	// otherwise, suspend the alert
	else {
		alertType = REMINDER_FOX_SUSPEND_ALERT_PREF + alertType;
	}
	
	reminderFox_prefs.setCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ENABLE_ALERT_PREF, alertType);
}

function processKeyPressedOnReminderTree(event) {
	if (event.keyCode == 46)
		removeReminder();
}


function reminderFox_showAlertSlider() {
	var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var windowEnumerator = windowManagerInterface.getEnumerator("navigator:browser");
	
	if (windowEnumerator.hasMoreElements()) {
		var oldestWindow = windowEnumerator.getNext();
		// Only show the alert  for the oldest window (the first browser you opened).  
		// We don't want each new window to have its own timeout to respond to, because we only
		// need to show one alert for all browser windows
		if ( window == oldestWindow ) {
			var alerts = Components.classes["@mozilla.org/alerts-service;1"].getService(Components.interfaces.nsIAlertsService);
			var alertType;
			try {
				alertType = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ENABLE_ALERT_PREF);
			} catch(e) {
				alertType = REMINDER_FOX_ENABLE_ALERT_PREF_ALL;
			}
			
			if ( alertType == REMINDER_FOX_ENABLE_ALERT_PREF_NONE ) {
			    return;
			}
		
			var upcomingReminders = "";
			var todaysReminders = "";
			
			if ( alertType == REMINDER_FOX_ENABLE_ALERT_PREF_TODAY || alertType == REMINDER_FOX_ENABLE_ALERT_PREF_ALL ) {
				var remindersArray = reminderFox_getTodaysReminders();
				for ( var i = 0; i < remindersArray.length; i++ ) {
					todaysReminders = todaysReminders + remindersArray[i].reminder;
					if ( i < remindersArray.length - 1 ) { 
						todaysReminders = todaysReminders + ", ";
					}
				}
			}
			
			if ( alertType ==REMINDER_FOX_ENABLE_ALERT_PREF_UPCOMING || alertType == REMINDER_FOX_ENABLE_ALERT_PREF_ALL ) {
				var remindersArray = reminderFox_getUpcomingReminders();
				for ( var i = 0; i < remindersArray.length; i++ ) {
					upcomingReminders = upcomingReminders + remindersArray[i].reminder;
					if ( i < remindersArray.length - 1 ) { 
						upcomingReminders = upcomingReminders + ", ";
					}
				}
			}
			
			if ( todaysReminders != "" && upcomingReminders != "" ) {
				todaysReminders = todaysReminders + REMINDER_SEPARATOR;
			} 
			var totalReminders = todaysReminders + upcomingReminders;
		
			if (totalReminders != "") {
				// don't want text on alert slider too long; truncate it after it gets big
				if ( totalReminders > reminderFox_STATUS_TEXT_MAX_LENGTH ) {
					totalReminders = totalReminders.substring( 0, reminderFox_STATUS_TEXT_MAX_LENGTH ) + "...";
				}
			
				upcomingArray = totalReminders.split(REMINDER_SEPARATOR);
				totalReminders = "";
				for (var i =0; i < upcomingArray.length; i++) {
					totalReminders += upcomingArray[i];
					if (i != upcomingArray.length - 1)
						totalReminders += ", ";
				}
			
				// don't want text on status bar too long; truncate it after it gets big
				if ( totalReminders.length >reminderFox_ALERT_TEXT_MAX_LENGTH ) {
					totalReminders = totalReminders.substring( 0, reminderFox_ALERT_TEXT_MAX_LENGTH ) + "...";
				}
				alerts.showAlertNotification("chrome://reminderfox/skin/images/fox.png", "Upcoming Reminders", totalReminders, false, "", null);
				reminderFox_storeTimeOfLastAlert();
			}
		}
		
		// Reshow alert after ALERT_TIMEOUT minutes.
		var alert_timeout = parseInt(reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ALERT_TIMEOUT_PREF));
		// convert from minutes to milliseconds	
		alert_timeout = alert_timeout * 60000; 
		window.setTimeout(reminderFox_showAlertSlider, alert_timeout);
	}
}



function reminderFox_saveReminders() {
	try {
		var savefile = reminderFox_prefs.getCharPref(REMINDER_FOX_BACKUP_FILE);
		//	savefile = "c:\\mozdata.txt";
		var reminders = reminderFox_prefs.getCharPref(REMINDER_FOX_REMINDERS);
		if ( reminders != "" ) {
				try {
					netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
				} catch (e) {
					alert("Permission to save file was denied.");
				}
				var file = Components.classes["@mozilla.org/file/local;1"]
					.createInstance(Components.interfaces.nsILocalFile);
				file.initWithPath( savefile );
				if ( file.exists() == false ) {
					file.create( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 420 );
				}
				var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
					.createInstance( Components.interfaces.nsIFileOutputStream );
				outputStream.init( file, 0x04 | 0x08 | 0x20, 420, 0 );
				
				var output = reminders + "\n\n";
				output = 	output + reminderFox_prefs.getCharPref(REMINDER_FOX_TODOS) + "\n";
				var result = outputStream.write( output, output.length );
				outputStream.close();
			}
		} catch(e) {
				// pref doesn't exist.  Do nothing.
		}	
}

function reminderFox_start() {
	reminderFox_loadDefaultPreferences();
	
	reminderFox_moveBox();
	
	// if this is the very first window opened, then let's set the timeout on it.
	reminderFox_initializeReminderFox();
	
	// Show the alert slider when the reminders are first initialized.
	// Only show if this is the oldest window (the first browser you opened).  That is, 
	// if you open a new window, we do not need to show the alert again.  
	reminderFox_showAlertSlider();

	// Initialize reminder fox for the browser window
	var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var windowEnumerator = windowManagerInterface.getEnumerator("navigator:browser");
	if (windowEnumerator.hasMoreElements()) {
		var oldestWindow = windowEnumerator.getNext();
		if ( window == oldestWindow ) {
			// if this is the very first window, save out the reminders
			reminderFox_saveReminders();		
		}	
		else {
			// otherwise if it's just a new window, we'll load it (tooltips, status bar)
			reminderFox_loadReminderFox(false);	
		}
	}
}

/*
function reminderFox_stop() {
	var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var windowEnumerator = windowManagerInterface.getEnumerator("navigator:browser");
	if (windowEnumerator.hasMoreElements()) {
		var oldestWindow = windowEnumerator.getNext();
		// if this is the very first window opened and it's closed, let's set the timeouts on the next oldest window
		if ( window == oldestWindow ) {
			var nextOldestWindow = windowEnumerator.getNext();
			if ( nextOldestWindow != null ) {
					nextOldestWindow.setTimeout(reminderFox_initializeReminderFox, 3600000);  // 10000 == 1 min
					var alert_timeout = parseInt(reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_ALERT_TIMEOUT_PREF));
					// convert from minutes to milliseconds	
					alert_timeout = alert_timeout * 60000; 
					nextOldestWindow.setTimeout(reminderFox_showAlertSlider, alert_timeout);
			}
		}
	}
}
*/


